"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .yelpreview import YelpReview, YelpReviewTypedDict
from enum import Enum
from exfunc_sdk import utils
from exfunc_sdk.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class GetBusinessReviewsSortBy(str, Enum):
    r"""The criteria to sort reviews (e.g., \"best_match\", \"newest\", etc.)"""

    BEST_MATCH = "best_match"
    NEWEST = "newest"
    OLDEST = "oldest"
    HIGHEST_RATED = "highest_rated"
    LOWEST_RATED = "lowest_rated"
    ELITES = "elites"


class GetBusinessReviewsRequestBodyTypedDict(TypedDict):
    business_id: str
    r"""The ID of the business to retrieve reviews for"""
    sort_by: NotRequired[GetBusinessReviewsSortBy]
    r"""The criteria to sort reviews (e.g., \"best_match\", \"newest\", etc.)"""
    page: NotRequired[int]
    r"""The page number of results to retrieve (default is 1)"""
    per_page: NotRequired[int]
    r"""The number of reviews to retrieve per page (default is 10)"""


class GetBusinessReviewsRequestBody(BaseModel):
    business_id: str
    r"""The ID of the business to retrieve reviews for"""

    sort_by: Optional[GetBusinessReviewsSortBy] = None
    r"""The criteria to sort reviews (e.g., \"best_match\", \"newest\", etc.)"""

    page: Optional[int] = None
    r"""The page number of results to retrieve (default is 1)"""

    per_page: Optional[int] = None
    r"""The number of reviews to retrieve per page (default is 10)"""


class GetBusinessReviewsYelpResponseResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class GetBusinessReviewsYelpResponseResponseBody(Exception):
    r"""GetBusinessReviews API server error response"""

    data: GetBusinessReviewsYelpResponseResponseBodyData

    def __init__(self, data: GetBusinessReviewsYelpResponseResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, GetBusinessReviewsYelpResponseResponseBodyData
        )


class GetBusinessReviewsYelpResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class GetBusinessReviewsYelpResponseBody(Exception):
    r"""GetBusinessReviews API user error response"""

    data: GetBusinessReviewsYelpResponseBodyData

    def __init__(self, data: GetBusinessReviewsYelpResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, GetBusinessReviewsYelpResponseBodyData)


class GetBusinessReviewsResponseBodyTypedDict(TypedDict):
    r"""GetBusinessReviews API successful response"""

    reviews: NotRequired[List[YelpReviewTypedDict]]


class GetBusinessReviewsResponseBody(BaseModel):
    r"""GetBusinessReviews API successful response"""

    reviews: Optional[List[YelpReview]] = None
