"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .googleproductreview import GoogleProductReview, GoogleProductReviewTypedDict
from exfunc_sdk import utils
from exfunc_sdk.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class GetProductReviewsRequestBodyTypedDict(TypedDict):
    product_id: str
    r"""The ID of the product for which to retrieve reviews"""
    country_code: NotRequired[str]
    r"""The country code for the reviews"""
    per_page: NotRequired[int]
    r"""Number of reviews to return per page (default is 10)"""


class GetProductReviewsRequestBody(BaseModel):
    product_id: str
    r"""The ID of the product for which to retrieve reviews"""

    country_code: Optional[str] = None
    r"""The country code for the reviews"""

    per_page: Optional[int] = None
    r"""Number of reviews to return per page (default is 10)"""


class GetProductReviewsGoogleResponseResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class GetProductReviewsGoogleResponseResponseBody(Exception):
    r"""GetProductReviews API server error response"""

    data: GetProductReviewsGoogleResponseResponseBodyData

    def __init__(self, data: GetProductReviewsGoogleResponseResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, GetProductReviewsGoogleResponseResponseBodyData
        )


class GetProductReviewsGoogleResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class GetProductReviewsGoogleResponseBody(Exception):
    r"""GetProductReviews API user error response"""

    data: GetProductReviewsGoogleResponseBodyData

    def __init__(self, data: GetProductReviewsGoogleResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, GetProductReviewsGoogleResponseBodyData)


class GetProductReviewsResponseBodyTypedDict(TypedDict):
    r"""GetProductReviews API successful response"""

    reviews: NotRequired[List[GoogleProductReviewTypedDict]]


class GetProductReviewsResponseBody(BaseModel):
    r"""GetProductReviews API successful response"""

    reviews: Optional[List[GoogleProductReview]] = None
