"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .twitteruser import TwitterUser, TwitterUserTypedDict
from exfunc_sdk import utils
from exfunc_sdk.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class GetUserFollowersRequestBodyTypedDict(TypedDict):
    username: str
    r"""The username of the Twitter user whose followers to retrieve"""
    count: NotRequired[int]
    r"""The number of followers to retrieve"""


class GetUserFollowersRequestBody(BaseModel):
    username: str
    r"""The username of the Twitter user whose followers to retrieve"""

    count: Optional[int] = None
    r"""The number of followers to retrieve"""


class GetUserFollowersTwitterResponseResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class GetUserFollowersTwitterResponseResponseBody(Exception):
    r"""GetUserFollowers API server error response"""

    data: GetUserFollowersTwitterResponseResponseBodyData

    def __init__(self, data: GetUserFollowersTwitterResponseResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, GetUserFollowersTwitterResponseResponseBodyData
        )


class GetUserFollowersTwitterResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class GetUserFollowersTwitterResponseBody(Exception):
    r"""GetUserFollowers API user error response"""

    data: GetUserFollowersTwitterResponseBodyData

    def __init__(self, data: GetUserFollowersTwitterResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, GetUserFollowersTwitterResponseBodyData)


class GetUserFollowersResponseBodyTypedDict(TypedDict):
    r"""GetUserFollowers API successful response"""

    followers: NotRequired[List[TwitterUserTypedDict]]


class GetUserFollowersResponseBody(BaseModel):
    r"""GetUserFollowers API successful response"""

    followers: Optional[List[TwitterUser]] = None
