"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .twitteruser import TwitterUser, TwitterUserTypedDict
from exfunc_sdk import utils
from exfunc_sdk.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class GetUserFollowingsRequestBodyTypedDict(TypedDict):
    username: str
    r"""The username of the Twitter user whose followings to retrieve"""
    count: NotRequired[int]
    r"""The number of followings to retrieve"""


class GetUserFollowingsRequestBody(BaseModel):
    username: str
    r"""The username of the Twitter user whose followings to retrieve"""

    count: Optional[int] = None
    r"""The number of followings to retrieve"""


class GetUserFollowingsTwitterResponseResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class GetUserFollowingsTwitterResponseResponseBody(Exception):
    r"""GetUserFollowings API server error response"""

    data: GetUserFollowingsTwitterResponseResponseBodyData

    def __init__(self, data: GetUserFollowingsTwitterResponseResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, GetUserFollowingsTwitterResponseResponseBodyData
        )


class GetUserFollowingsTwitterResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class GetUserFollowingsTwitterResponseBody(Exception):
    r"""GetUserFollowings API user error response"""

    data: GetUserFollowingsTwitterResponseBodyData

    def __init__(self, data: GetUserFollowingsTwitterResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, GetUserFollowingsTwitterResponseBodyData)


class GetUserFollowingsResponseBodyTypedDict(TypedDict):
    r"""GetUserFollowings API successful response"""

    tweets: NotRequired[List[TwitterUserTypedDict]]


class GetUserFollowingsResponseBody(BaseModel):
    r"""GetUserFollowings API successful response"""

    tweets: Optional[List[TwitterUser]] = None
