"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from exfunc_sdk import utils
from exfunc_sdk.types import BaseModel
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict


class SearchCompaniesRequestBodyTypedDict(TypedDict):
    name: NotRequired[str]
    r"""The name of the company to search for"""
    locations: NotRequired[List[str]]
    sizes: NotRequired[List[str]]
    industries: NotRequired[List[str]]
    page: NotRequired[int]
    r"""Page number for pagination (default is 1)"""


class SearchCompaniesRequestBody(BaseModel):
    name: Optional[str] = None
    r"""The name of the company to search for"""

    locations: Optional[List[str]] = None

    sizes: Optional[List[str]] = None

    industries: Optional[List[str]] = None

    page: Optional[int] = None
    r"""Page number for pagination (default is 1)"""


class SearchCompaniesLinkedinResponseResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class SearchCompaniesLinkedinResponseResponseBody(Exception):
    r"""SearchCompanies API server error response"""

    data: SearchCompaniesLinkedinResponseResponseBodyData

    def __init__(self, data: SearchCompaniesLinkedinResponseResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(
            self.data, SearchCompaniesLinkedinResponseResponseBodyData
        )


class SearchCompaniesLinkedinResponseBodyData(BaseModel):
    message: Optional[str] = None
    r"""Error message string"""


class SearchCompaniesLinkedinResponseBody(Exception):
    r"""SearchCompanies API user error response"""

    data: SearchCompaniesLinkedinResponseBodyData

    def __init__(self, data: SearchCompaniesLinkedinResponseBodyData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, SearchCompaniesLinkedinResponseBodyData)


class CompaniesTypedDict(TypedDict):
    url: NotRequired[str]
    r"""URL to the company's profile"""
    uid: NotRequired[str]
    r"""LinkedIn uid"""
    name: NotRequired[str]
    r"""Name of the company"""
    website_url: NotRequired[str]
    r"""Company's website URL"""


class Companies(BaseModel):
    url: Optional[str] = None
    r"""URL to the company's profile"""

    uid: Optional[str] = None
    r"""LinkedIn uid"""

    name: Optional[str] = None
    r"""Name of the company"""

    website_url: Optional[str] = None
    r"""Company's website URL"""


class SearchCompaniesResponseBodyTypedDict(TypedDict):
    r"""Successful response with a list of companies"""

    companies: NotRequired[List[CompaniesTypedDict]]


class SearchCompaniesResponseBody(BaseModel):
    r"""Successful response with a list of companies"""

    companies: Optional[List[Companies]] = None
